/* This group of functions does the character class compression.
   It goes over the dfa and relabels the arcs with the partitions
   of characters in the NFA.  The partitions are stored in the
   array class.

	Will Cohen
	10/25/89

*/

#include <stdio.h>
#include "dlg.h"

int	class_no;		/* number classes actually used */
int	first_el[NUM_CLASS];	/* first element in each class partition */
set	class[NUM_CLASS];	/* holds partitions from class compression */

/* relabel builds partitions from the the labels on the transistion
   arcs in the NFA.  It then goes through and relabels the arcs with
   the partitions, character classes
*/

relabel()
{
	partition();
	class_label();
}

/* makes character class sets for new labels */
partition()
{
	set current_class;
	set unpart_chars;
	register int label1;
	unsigned *start1;
	register int i;

	unpart_chars = used_chars;
	/* EOF (-1+1) alway in class 0 */
	class[0] = set_of(0);
	first_el[0] = 0;
	used_classes = set_of(0);
	unpart_chars = set_dif(unpart_chars, class[0]);
	class_no = 1;
	start1 = &(unpart_chars.setword[0]);
	set_remove_int(unpart_chars, label1, start1);
	while (label1 != nil){
		current_class = set_of(label1);
		/* don't look for equivalent labels if c <= 1 */
		if (compress > 1){
			current_class = unpart_chars;
			set_or_int(current_class, label1);
			for(i=0; i<nfa_pool; i++){
				if (set_el(label1,nfa(i).label))
					current_class = 
					  set_and(current_class,nfa(i).label);
				else
					current_class = 
					  set_and(current_class,
					  set_not(nfa(i).label));
				}
			unpart_chars = set_dif(unpart_chars,current_class);
			}
		set_or_int(used_classes, class_no);
		first_el[class_no] = label1;
		class[class_no++] = current_class;
		set_remove_int(unpart_chars,label1,start1);
		}
}

/* puts class labels in place of old character labels */
class_label()
{
	set old_label;
	set new_label;
	register int i,j;
	
	for (i = 0; i<nfa_pool; i++){
		new_label = set_of(nil);
		old_label = nfa(i).label;
		for (j = 0; j<class_no; j++){
				/* if one element of class in old_label,
				   all elements are. */
				if (set_el(first_el[j],old_label))
					set_or_int(new_label,j);
			}
		nfa(i).label = new_label;
		}
}
